/*
   This version of insertion sort is from
   "Algorithms in Java, 3rd Ed", by Robert Sedgewick,
   page 286.
*/
void insertionSort(int* a, int p, int q)
{
   int i, temp;

   if (q == p) return;  // array of size 1

   // bubble the minimum down to the beginning of a[]
   for (i = q; i > p; i--)
      if (a[i-1] > a[i])
      {
         temp   = a[i-1];
         a[i-1] = a[i];
         a[i]   = temp;
      }

   if (q == p+1) return;  // array of size 2

   for (i = p+2; i <= q; i++)
   {
      int v = a[i];
      int j = i;
      while (v < a[j-1])
      {
         a[j] = a[j-1];
         j--;
      }
      a[j] = v;
   }
}//insertionSort()

